/**
 * RewindableBingoProgressionクラス
 * 1から75までの数字をランダムにもれなくだぶりなく
 * 持つ数列（ビンゴ数列）を持つ。
 * ビンゴ数列を取得するためのメソッドを持つ。
 * 途中や最後までビンゴ数列の要素を取得した後も、
 * goHeadメソッドでまた最初から取得可能。
 * @author Hirata Atsushi
 */

import java.util.*;

class RewindableBingoProgression extends BingoProgression 
                                 implements Iterator{

  static final int     BINGO_MAX_NUMBER         = 75;
    
  private ArrayList <Integer> vals = new ArrayList<Integer>();
  private Integer currentIndex = 0;
    
  public RewindableBingoProgression(){
    while(super.hasNext()){
      vals.add((Integer)super.next());
    }
    currentIndex = 0;
  }

  public void goHead(){
    currentIndex = 0;
  }
  
  // Iteratorインタフェイスの実装
  public boolean hasNext(){
    if (currentIndex < BINGO_MAX_NUMBER) {
      return true;
    } else {
      return false;
    }
  }
  
  public Integer next(){
    if (currentIndex < BINGO_MAX_NUMBER) {
      Integer val = vals.get(currentIndex);
      currentIndex++;
      return val;
    } else {
      throw new NoSuchElementException();
    }
  }
  
  public void remove(){
    //今の所値削除機能のサポートの予定なし
    throw new UnsupportedOperationException();
  }
}